//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_chart_window

extern string LineName        = "Line1";
extern color  LineColor       = Red; 
extern int    LineStyle       = STYLE_SOLID;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init()   { return(0); }
int deinit() { return(0); }
int start()
{
   static string symbolName = "";
   if (ObjectFind(LineName)==-1 || symbolName != _Symbol)
   {
      ObjectDelete(LineName);
      ObjectCreate(LineName, OBJ_HLINE, 0, Time[25], Close[0], Time[0], Close[0]);
         ObjectSet(LineName, OBJPROP_STYLE, LineStyle);
         ObjectSet(LineName, OBJPROP_COLOR, LineColor);
            symbolName = _Symbol;
   }
      
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {   
      int testbar = 1; if (alertsOnCurrent) testbar = 0;
      double valc = ObjectGetValueByShift(LineName,testbar);
      double valp = ObjectGetValueByShift(LineName,testbar+1);
         
      //
      //
      //
      //
      //
            
      if (Close[0]>valc && Close[1]<valp) doAlert(0," trend line crossed up");
      if (Close[0]<valc && Close[1]>valp) doAlert(0," trend line crossed down");
   }         
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" "+LineName+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+"trendLine alerts",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}